export declare type ScrollBehavior = 'auto' | 'instant' | 'smooth';
export declare type ScrollLogicalPosition = 'start' | 'center' | 'end' | 'nearest';
export declare type ScrollMode = 'always' | 'if-needed';
export interface Options {
    block?: ScrollLogicalPosition;
    inline?: ScrollLogicalPosition;
    scrollMode?: ScrollMode;
    boundary?: CustomScrollBoundary;
}
export interface CustomScrollBoundaryCallback {
    (parent: Element): boolean;
}
export declare type CustomScrollBoundary = Element | CustomScrollBoundaryCallback;
export declare type CustomScrollAction = {
    el: Element;
    top: number;
    left: number;
};
export interface CustomScrollBehaviorCallback<T> {
    (actions: CustomScrollAction[]): T;
}
